#include "FiveWin.ch"
#include "gif.ch"

STATIC hResources, oDlg, oDlg1, c_path, c_path1, lRun := .F., nBrush := 3
STATIC oTextFont1, oTextFont2, oABtn[1], oSBtn[7], oImage, cTyp := "A_" 

FUNCTION MAIN()
LOCAL oTextFont, oRad, nTyp := 1 

c_path	:= cFilePath(GetModuleFileName( GetInstance() ) )
c_path1	:= c_Path + "IMAGES\"
SetBalloon( .T. ) // Balloon shape required for tooltips

DEFINE FONT oTextFont1 NAME "Arial" SIZE 0, -14
DEFINE FONT oTextFont2 NAME "Arial" SIZE 0, -18 BOLD

// oTextFont := TFont():New( "Arial", 0, 12,.F.,.F.,  0,  0,  0,.F.,.F.)
hResources := GetResources()
SET RESOURCES TO c_path1 + "ANIBTN.dll"

DEFINE DIALOG oDlg ;
FROM  0, 0 TO 460, 440 PIXEL TITLE "Gif-Test"  ICON "FAVORITE"   

@ 10, 80 IMAGE oImage RESOURCE "C_30"  OF oDlg ; // start-frame
SIZE 80, 80 PIXEL  NOBORDER
oImage:cTooltip := "Image"
oImage:lTransparent := .T.

@ 90, 80 BTNBMP oABtn[1] SIZE 60, 30 OF oDlg  2007 ;
FILENAME c_path1 + "Run.bmp" ;
LEFT BORDER ;
PROMPT "&Image-Run" ;
FONT oTextFont2 ;
ACTION ( 	lRun := .T., RUN_ACT(cTyp, oImage) )
oABtn[1]:lTransparent := .T.
oABtn[1]:cTooltip :=  { "Run" + CRLF + ;
                                 "Image-animation","RUN", 1, CLR_BLACK, 14089979 }

@ 90, 150 RADIO oRad VAR nTyp OF oDlg PIXEL ;
ITEMS "Typ &1", "Typ &2", "Typ &3" _3D SIZE 50, 15 ;
HELPID 100, 101, 102 ;
ON CHANGE ( IIF( nTyp = 1, cTyp := "A_", NIL ), ;
			IIF( nTyp = 2, cTyp := "B_", NIL ), ;
			IIF( nTyp = 3, cTyp := "C_", NIL ) )
AEval( oRad:aItems, { | oRad | oRad:lTransparent := .T., ;
					      oRad:SetFont ( oTextFont2 ), ;
                                              oRad:nClrText := 0 } )

// -----------------------

@ 150, 10 BTNBMP oSBtn[1] SIZE 60, 30 OF oDlg  2007 ;
FILENAME c_path1 + "Color.bmp" ;
LEFT ;
PROMPT "&Color" ;
FONT oTextFont1 ;
ACTION ( nBrush := 1, DRAW_BACK( oDlg, nBrush, 16762767 ) )
oSBtn[1]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[1]:nLayout := 2
oSBtn[1]:SetColor( 128 )
oSBtn[1]:cTooltip :=  { "use color" + CRLF + ;
                               "Background","COLOR", 1, CLR_BLACK, 16762767 }

@ 150, 80 BTNBMP oSBtn[2] SIZE 60, 30 OF oDlg  2007 ;
FILENAME c_path1 + "Gradient.bmp" ;
LEFT ;
PROMPT "&Gradient" ;
FONT oTextFont1 ;
ACTION ( nBrush := 2, DRAW_BACK( oDlg, nBrush, 16762767, 16773088, .T., 0.2 ) ) 
oSBtn[2]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[2]:nLayout := 2
oSBtn[2]:SetColor( 128 )
oSBtn[2]:cTooltip :=  { "use Gradient" + CRLF + ;
                               "Background","GRADIENT", 1, CLR_BLACK, 14089979 }

@ 150, 150 BTNBMP oSBtn[3] SIZE 60, 30 OF oDlg  2007 ;
FILENAME c_path1 + "Brush1.bmp" ;
LEFT ;
PROMPT "&Brush" ;
FONT oTextFont1 ;
ACTION ( nBrush := 3, DRAW_BACK( oDlg, nBrush, , , , , "Marble.bmp" ) )
oSBtn[3]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[3]:nLayout := 2
oSBtn[3]:SetColor( 128 )
oSBtn[3]:cTooltip :=  { "use Brush" + CRLF + ;
                               "Background","BRUSH", 1, CLR_BLACK, 14089979 }

@ 190, 10 BTNBMP oSBtn[4] SIZE 60, 30 OF oDlg  2007 ;
FILENAME c_path1 + "Image.bmp" ;
LEFT ;
PROMPT "&Image" ;
FONT oTextFont1 ;
ACTION ( nBrush := 4, DRAW_BACK( oDlg, nBrush, , , , , ,"Picture.jpg" ) ) 
oSBtn[4]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[4]:nLayout := 2
oSBtn[4]:SetColor( 128 )
oSBtn[4]:cTooltip :=  { "use Image" + CRLF + ;
                               "Background","IMAGE", 1, CLR_BLACK, 14089979 }

@ 190, 80 BTNBMP oSBtn[5] SIZE 60, 30 OF oDlg  2007 ;
FILENAME c_path1 + "Stop.bmp" ;
LEFT ;
PROMPT "&STOP ani." ;
FONT oTextFont1 ;
ACTION lRun := .F.  
oSBtn[5]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[5]:nLayout := 2
oSBtn[5]:SetColor( 128 )
oSBtn[5]:cTooltip :=  { "STOP" + CRLF + ;
                                "animation","STOP", 1, CLR_BLACK, 14089979 }

@ 190, 150 BTNBMP oSBtn[6] SIZE 60, 30 OF oDlg  2007 ;
FILENAME  c_path1 + "Exit.bmp" ;
LEFT ;
PROMPT "&Exit" ;
FONT oTextFont1 ;
ACTION oDlg:End() 
oSBtn[6]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 10526975, 16777215 }, ;
	  { 0.5, 16777215, 10526975 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[6]:nLayout := 2
oSBtn[6]:SetColor( 128 )
oSBtn[6]:cTooltip :=  { "Exit" + CRLF + ;
                                "Animation-Test","EXIT", 1, CLR_BLACK, 14089979 }

ACTIVATE DIALOG oDlg CENTERED ;
ON INIT DRAW_BACK( oDlg, 3, , , , , "Marble.bmp" )
 
SET RESOURCES TO

oTextFont1:End()
oTextFont2:End()

RETURN NIL

// ------------ SAMPLE -----------

FUNCTION RUN_ACT(cStyle, oImage)
LOCAL oDlg1, oProg1, oProg2
   
DEFINE DIALOG oDlg1 TITLE "Progress Bars"
   
@ 1, 1 PROGRESS oProg1 SIZE 80, 12

@ 1, 20 PROGRESS oProg2 SIZE 12, 50 VERTICAL
   
@ 3,  9 BUTTON "Exit" ACTION ( lRun := .F., oDlg1:End() )
 
oDlg1:bStart = { || GIF_RUN( oDlg1, oProg1, oProg2, cStyle, oImage ) }
   
ACTIVATE DIALOG oDlg1 CENTER NOWAIT ;
ON INIT ( oProg1:SetRange( 0, 100 ), oProg1:SetStep( 1 ),;
                oProg2:SetRange( 0, 100 ), oProg2:SetStep( 1 ) )

RETURN NIL  

// -----------------

FUNCTION GIF_RUN( oDlg1, oProg1, oProg2, cStyle, oImage )
LOCAL n, I := 0, nValue 

IF cTyp = "A_"
	nValue := 20
ELSEIF cTyp = "B_"
	nValue := 18
ELSEIF cTyp = "C_"
	nValue := 12
ENDIF

DO WHILE lRun = .T.
	FOR n = 1 to 116 
		IF lRun = .T.
			oProg1:SetPos( n )
			oProg2:SetPos( n )
			SysRefresh()
			I++
			IF I > nValue
				I := 1
			ENDIF
			SYSWAIT(0.1)
			oImage:SetBMP( cStyle + LTRIM(STR(I)) )
		ELSE
			EXIT
		ENDIF
		IF n = 116
			lRun = .F.	
		ENDIF
	NEXT
ENDDO
oDlg1:End()
oImage:SetBMP( "C_30" )

RETURN NIL

// --------  BACKGROUND ---------------

FUNCTION DRAW_BACK( oWnd, nStyle, nColor1, nColor2, lDirect, nMove, cBrush, cImage ) 
LOCAL hDC, oBrush, oImage, aGrad, I := 1
LOCAL aRect := GETCLIENTRECT( oWnd:hWnd ) 

IF nStyle = 1 // COLOR
	DEFINE BRUSH oBrush COLOR nColor1
ENDIF
IF nStyle = 2 // GRADIENT
	aGrad := { { nMove, nColor1, nColor2 }, { nMove, nColor2, nColor1 } }
	hDC = CreateCompatibleDC( oWnd:GetDC() )
	hBmp = CreateCompatibleBitMap( oWnd:hDC, aRect[4], aRect[3] )
	hBmpOld = SelectObject( hDC, hBmp )
	GradientFill( hDC, 0, 0, aRect[3], aRect[4], aGrad, lDirect )
	DeleteObject( oWnd:oBrush:hBrush )
	oBrush := TBrush():New( ,,,, hBmp )
	oBrush:Cargo  := aGrad
	SelectObject( hDC, hBmpOld )
	ReleaseDC(hDC)
ENDIF
IF nStyle = 3 // BMP-BRUSH
	IF FILE( c_path1 + cBrush ) 
		DEFINE BRUSH oBrush FILE c_path1 + cBrush
	ELSE
		IF !EMPTY(cImage)
			MsgAlert( "File : " + cBrush + CRLF + ;
					"does not exist" + CRLF + ; 
				        "to create Background !", "ATTENTION" ) 
		ENDIF
	ENDIF
ENDIF
IF nStyle = 4 // Image ADJUSTED
	IF FILE( c_path1 + cImage ) 
		DEFINE IMAGE oImage FILE c_path1 + cImage
		oBrush := TBrush():new( ,,,, ResizeBmp( oImage:hBitmap, aRect[4], aRect[3], .T. ) ) 
		oImage:End()
	ELSE
		IF !EMPTY(cImage)
			MsgAlert( "File  : " + cImage + CRLF + ;
					"does not exist" + CRLF + ; 
				        "to create Background !", "ATTENTION" ) 
		ENDIF
	ENDIF
ENDIF
IF nBrush = 1
	oABtn[1]:SetColor( 255 )
	oABtn[1]:Refresh()
ELSEIF nBrush = 2
	oABtn[1]:SetColor( 0 )
	oABtn[1]:Refresh()
ELSEIF nBrush = 3
	oABtn[1]:SetColor( 255 )
	oABtn[1]:Refresh()
ELSEIF nBrush = 4
	oABtn[1]:SetColor( 65535 )
	oABtn[1]:Refresh()
ENDIF

oWnd:Setbrush( oBrush )
//oBrush:End()

RETURN( NIL)

// -----------

DLL32 FUNCTION BWCCRegister( hInst AS LONG ) AS WORD PASCAL LIB "Anibtn.DLL"

